//---------------------------------------------------------------------------

#ifndef mainH
#define mainH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "FIBExTreeComboBox.hpp"
#include "FIBExTreeList.hpp"
#include "FIBExTreeView.hpp"
#include "ImageComboBox.hpp"
#include <ComCtrls.hpp>
#include <DB.hpp>
#include <DBGrids.hpp>
#include <Dialogs.hpp>
#include <ExtCtrls.hpp>
#include <Grids.hpp>
#include <ImgList.hpp>
#include <Mask.hpp>
#include <Menus.hpp>
#include <ToolWin.hpp>
#include "FIBDatabase.hpp"
#include "FIBDataSet.hpp"
#include "ImageComboBox.hpp"
#include "pFIBDatabase.hpp"
#include "pFIBDataSet.hpp"
#include "FIBExTreeColumnList.hpp"
#include <Buttons.hpp>
#include "FIBExTrees.hpp"
#include "FIBExDynTreeColumnList.hpp"
#include "FIBExDynTreeComboBox.hpp"
#include "FIBExDynTreeList.hpp"
#include "FIBExDynTreeView.hpp"
//---------------------------------------------------------------------------
class TF_main : public TForm
{
__published:	// IDE-managed Components
        TMainMenu *MainMenu1;
        TMenuItem *File1;
        TMenuItem *Exit1;
        TMenuItem *Edit1;
        TMenuItem *AddItem1;
        TMenuItem *AddChilditem1;
        TMenuItem *Edititem1;
        TMenuItem *DeleteItem1;
        TMenuItem *N5;
        TMenuItem *Checkallitems;
        TMenuItem *Uncheckallitems;
        TMenuItem *N1;
        TMenuItem *Sortitems1;
        TMenuItem *Moveoneup;
        TMenuItem *Moveonedown;
        TMenuItem *Moveonetoplevel;
        TMenuItem *Moveonedownlevel;
        TMenuItem *Option1;
        TMenuItem *EditItemsafterInsert;
        TMenuItem *UpdateImagelevel;
        TMenuItem *HideTreePopUpImages1;
        TMenuItem *N4;
        TMenuItem *AutoCheckChildren;
        TMenuItem *DisableCheck;
        TMenuItem *View1;
        TMenuItem *OpHideImages;
        TMenuItem *OpHideStateImages;
        TMenuItem *OpShowFieldID;
        TMenuItem *N2;
        TMenuItem *FullCollapse1;
        TMenuItem *FullExpand1;
        TMenuItem *Help1;
        TMenuItem *English1;
        TMenuItem *Russian1;
        TMenuItem *About1;
        TImageList *ImageTool;
        TImageList *ImageTree;
        TOpenDialog *OD;
        TImageList *ToolbarList;
        TImageList *ImageState;
        TDataSource *DataSource1;
        TDataSource *DataSource2;
        TpFIBDatabase *IBD;
        TpFIBTransaction *Tr_Read;
        TpFIBTransaction *Tr_Write;
        TpFIBDataSet *IBDataSet1;
        TpFIBDataSet *IBDataSet2;
        TFIBIntegerField *IBDataSet2ID;
        TFIBIntegerField *IBDataSet2PARENT;
        TFIBStringField *IBDataSet2NAME;
        TFIBIntegerField *IBDataSet2CCOUNT;
        TFIBIntegerField *IBDataSet2SORTINDEX;
        TFIBIntegerField *IBDataSet2IMAGEINDEX;
        TFIBIntegerField *IBDataSet2STATEINDEX;
        TFIBIntegerField *IBDataSet2NODE_LEVEL;
        TFIBStringField *IBDataSet2FULLPATH;
        TMenuItem *AutoUnCheckParents;
        TMenuItem *N3;
        TMenuItem *AutoUnCheckChildren;
        TMenuItem *AutoCheckParents;
        TPageControl *PageTrees;
        TTabSheet *TabSheet1;
        TTabSheet *TabSheet2;
        TPageControl *PageControl1;
        TTabSheet *TabSheet3;
        TStatusBar *StatusBar1;
        TToolBar *ToolBar2;
        TPanel *Panel1;
        TLabel *Label1;
        TComboBox *ComboBox1;
        TToolButton *TB_CHECLALL;
        TToolButton *TB_UNCHECLALL;
        TPanel *Panel16;
        TLabel *Label13;
        TComboBox *ComboFilter;
        TEdit *E_FILTER;
        TToolBar *ToolBar1;
        TToolButton *TB_ADDITEM;
        TToolButton *TB_ADDCHILD;
        TToolButton *TB_EDIT;
        TToolButton *TB_DELETE;
        TImageComboBox *ImageComboBox1;
        TImageComboBox *ImageComboBox2;
        TToolButton *TB_SORT;
        TToolButton *TB_UP;
        TToolButton *TB_DN;
        TToolButton *TB_TOP1;
        TToolButton *TB_DOWN;
        TToolButton *ToolButton8;
        TToolButton *TB_COLLAPSE;
        TToolButton *TB_EXPAND;
        TToolButton *ToolButton1;
        TToolButton *TB_LOCATE;
        TToolButton *ToolButton2;
        TToolButton *TB_FILTER;
        TPanel *Panel2;
        TComboBox *ComboLevels;
        TFIBExTreeView *FIBExTreeView1;
        TMemo *Memo1;
        TTabSheet *TabSheet7;
        TFIBExTreeColumnList *FIBExTreeColumnList1;
        TPanel *Panel15;
        TLabel *Label10;
        TSpeedButton *TBC_CHECKALL;
        TSpeedButton *TBC_UNCHECKALL;
        TCheckBox *CB_CUSTOM_COLOR;
        TCheckBox *CB_CUSTOM_TEXT;
        TCheckBox *CB_LINES;
        TCheckBox *CB_ROWSELECT;
        TComboBox *ComboBox8;
        TPanel *Panel19;
        TLabel *Label15;
        TComboBox *ComboLFilter;
        TEdit *E_LFILTER;
        TToolBar *ToolBar5;
        TToolButton *TBL_ADDITEM;
        TToolButton *TBL_ADDCHILD;
        TToolButton *TBL_EDIT;
        TToolButton *TBL_DELETE;
        TImageComboBox *ImageComboBox3;
        TImageComboBox *ImageComboBox4;
        TToolButton *TBL_SORT;
        TToolButton *TBL_UP;
        TToolButton *TBL_DN;
        TToolButton *TBL_TOP;
        TToolButton *TBL_DOWN;
        TToolButton *ToolButton14;
        TToolButton *TBL_COLLAPSE;
        TToolButton *TBL_EXPAND;
        TToolButton *ToolButton17;
        TToolButton *TBL_LOCATE;
        TToolButton *ToolButton19;
        TToolButton *TBL_FILTER;
        TToolButton *ToolButton3;
        TToolButton *TBL_USERTEST;
        TPanel *Panel17;
        TComboBox *ComboLLevels;
        TTabSheet *TabSheet4;
        TSplitter *Splitter2;
        TPanel *Panel7;
        TPanel *Panel8;
        TFIBExTreeView *FIBExTreeView4;
        TPanel *Panel9;
        TPanel *Panel10;
        TToolBar *ToolBar3;
        TToolButton *TB_BACK;
        TToolButton *ToolButton4;
        TToolButton *TB_LARGE;
        TToolButton *TB_SMALL;
        TToolButton *TB_LIST;
        TToolButton *TB_REPORT;
        TLabel *Label4;
        TToolBar *ToolBar4;
        TPanel *Panel11;
        TLabel *Label5;
        TComboBox *ComboBox3;
        TToolButton *TBL_CHECKALL;
        TToolButton *TBL_UNCHECKALL;
        TFIBExTreeList *FIBExTreeList1;
        TTabSheet *TabSheet5;
        TPanel *Panel4;
        TPanel *Panel6;
        TFIBExTreeView *FIBExTreeView5;
        TPanel *Panel5;
        TLabel *Label3;
        TLabel *Label14;
        TGroupBox *GroupBox1;
        TLabel *Label12;
        TCheckBox *CheckBox1;
        TCheckBox *CheckBox4;
        TComboBox *ComboBLevels;
        TRadioGroup *RadioGroup1;
        TGroupBox *GroupBox2;
        TCheckBox *CheckBox2;
        TButton *Button1;
        TCheckBox *CheckBox5;
        TFIBExTreeComboBox *FIBExTreeComboBox1;
        TCheckBox *CheckBox3;
        TGroupBox *GroupBox3;
        TLabel *Label16;
        TLabel *Label17;
        TComboBox *ComboCFilter;
        TEdit *E_CFILTER;
        TTabSheet *TabSheet6;
        TSplitter *Splitter1;
        TPanel *Panel3;
        TLabel *Label2;
        TLabel *Label7;
        TLabel *Label8;
        TLabel *Label9;
        TComboBox *ComboBox5;
        TComboBox *ComboBox6;
        TComboBox *ComboBox7;
        TCheckBox *CheckCopyImages;
        TFIBExTreeView *FIBExTreeView3;
        TFIBExTreeView *FIBExTreeView2;
        TTabSheet *TabSheet8;
        TSplitter *Splitter3;
        TPanel *Panel13;
        TLabel *Label6;
        TCheckBox *CheckBox6;
        TDBGrid *DBGrid1;
        TButton *B_CREATEDATA;
        TFIBExTreeView *FIBExTreeView6;
        TTabSheet *TabSheet9;
        TPanel *Panel14;
        TDBGrid *DBGrid2;
        TPageControl *PageDynControl;
        TTabSheet *TabSheet10;
        TFIBExDynTreeView *FIBExDynTreeView1;
        TTabSheet *TabSheet11;
        TFIBExDynTreeColumnList *FIBExDynTreeColumnList1;
        TTabSheet *TabSheet12;
        TFIBExDynTreeList *FIBExDynTreeList1;
        TToolBar *ToolBar6;
        TToolButton *TB_DBACK;
        TToolButton *ToolButton6;
        TToolButton *TB_DLARGE;
        TToolButton *TB_DSMALL;
        TToolButton *TB_DLIST;
        TToolButton *TB_DREPORT;
        TLabel *Label11;
        TTabSheet *TabSheet13;
        TLabel *Label18;
        TFIBExDynTreeComboBox *FIBExDynTreeComboBox1;
        TRadioGroup *RG_COMBO1;
        TGroupBox *RG_COMBO2;
        TCheckBox *CB_DFEX;
        TCheckBox *CB_DSLS;
        TMemo *Memo_key;
        TPanel *P_DYN;
        TLabel *LSQL;
        TLabel *Label20;
        TMemo *Memo_sql;
        TRadioGroup *RLevel0;
        TRadioGroup *RLevel1;
        TRadioGroup *RLevel2;
        TCheckBox *CB_Reload;
        TComboBox *CB_Levels;
        TImageList *ImageDyn1;
        TImageList *ImageDyn2;
        TPanel *Panel12;
        TCheckBox *CB_DCUSTOM_COLOR;
        TCheckBox *CB_DCUSTOM_TEXT;
        TCheckBox *CB_DLINES;
        TCheckBox *CB_DROWSELECT;
        TCheckBox *CheckBox8;
        void __fastcall Exit1Click(TObject *Sender);
        void __fastcall FormActivate(TObject *Sender);
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
        void __fastcall TB_ADDITEMClick(TObject *Sender);
        void __fastcall TB_ADDCHILDClick(TObject *Sender);
        void __fastcall TB_EDITClick(TObject *Sender);
        void __fastcall TB_DELETEClick(TObject *Sender);
        void __fastcall ImageComboBox1Change(TObject *Sender);
        void __fastcall ImageComboBox2Change(TObject *Sender);
        void __fastcall TB_SORTClick(TObject *Sender);
        void __fastcall TB_UPClick(TObject *Sender);
        void __fastcall TB_DNClick(TObject *Sender);
        void __fastcall TB_TOP1Click(TObject *Sender);
        void __fastcall TB_DOWNClick(TObject *Sender);
        void __fastcall TB_COLLAPSEClick(TObject *Sender);
        void __fastcall TB_EXPANDClick(TObject *Sender);
        void __fastcall TB_LOCATEClick(TObject *Sender);
        void __fastcall TB_FILTERClick(TObject *Sender);
        void __fastcall ComboBox1Change(TObject *Sender);
        void __fastcall ComboBox2Change(TObject *Sender);
        void __fastcall TB_CHECLALLClick(TObject *Sender);
        void __fastcall TB_UNCHECLALLClick(TObject *Sender);
        void __fastcall PageControl1Change(TObject *Sender);
        void __fastcall EditItemsafterInsertClick(TObject *Sender);
        void __fastcall UpdateImagelevelClick(TObject *Sender);
        void __fastcall HideTreePopUpImages1Click(TObject *Sender);
        void __fastcall AutoCheckChildrenClick(TObject *Sender);
        void __fastcall DisableCheckClick(TObject *Sender);
        void __fastcall OpHideImagesClick(TObject *Sender);
        void __fastcall OpHideStateImagesClick(TObject *Sender);
        void __fastcall OpShowFieldIDClick(TObject *Sender);
        void __fastcall English1Click(TObject *Sender);
        void __fastcall About1Click(TObject *Sender);
        void __fastcall FIBExTreeView1Change(TObject *Sender,
          TTreeNode *Node);
        void __fastcall ComboBox3Change(TObject *Sender);
        void __fastcall ComboBox4Change(TObject *Sender);
        void __fastcall TBL_CHECKALLClick(TObject *Sender);
        void __fastcall TBL_UNCHECKALLClick(TObject *Sender);
        void __fastcall TB_LARGEClick(TObject *Sender);
        void __fastcall RadioGroup1Click(TObject *Sender);
        void __fastcall CheckBox1Click(TObject *Sender);
        void __fastcall CheckBox4Click(TObject *Sender);
        void __fastcall CheckBox3Click(TObject *Sender);
        void __fastcall CheckBox2Click(TObject *Sender);
        void __fastcall Button1Click(TObject *Sender);
        void __fastcall CheckBox6Click(TObject *Sender);
        void __fastcall B_CREATEDATAClick(TObject *Sender);
        void __fastcall FormShow(TObject *Sender);
        void __fastcall FIBExTreeComboBox1ChangeKeyValue(TObject *Sender);
        void __fastcall FIBExTreeView1BeforeDeleteNode(TObject *Sender,
          TTreeNode *Node, bool &AllowDelete);
        void __fastcall FIBExTreeView1BeforeCheck(TObject *Sender,
          TTreeNode *Node, bool &AllowChecked);
        void __fastcall FIBExTreeView1AfterUpdateImage(TObject *Sender,
          TTreeNode *Node);
        void __fastcall ComboBox5Change(TObject *Sender);
        void __fastcall FIBExTreeView2BeforeDropCopy(TObject *Sender,
          TTreeNode *&NewParent, TTreeCopyMode &Mode, bool &AllowImages,
          bool &AllowCopy);
        void __fastcall FIBExTreeView2BeforeDropRemove(TObject *Sender,
          TTreeNode *&NewParent, bool &AllowImages, bool &AllowRemove);
        void __fastcall FIBExTreeView4Change(TObject *Sender,
          TTreeNode *Node);
        void __fastcall FIBExTreeList1BeforeDeleteItem(TObject *Sender,
          TListItem *Item, bool &AllowDelete);
        void __fastcall FIBExTreeList1DblClick(TObject *Sender);
        void __fastcall FIBExTreeList1AfterUpdateImage(TObject *Sender,
          TListItem *Item);
        void __fastcall FIBExTreeList1AfterDeleteItem(TObject *Sender);
        void __fastcall FIBExTreeList1AfterSortItems(TObject *Sender);
        void __fastcall FIBExTreeList1AfterLocateItem(TObject *Sender,
          TListItem *Item);
        void __fastcall CheckBox5Click(TObject *Sender);
        void __fastcall FIBExTreeView6Change(TObject *Sender,
          TTreeNode *Node);
        void __fastcall FIBExTreeView4BeforeDeleteNode(TObject *Sender,
          TTreeNode *Node, bool &AllowDelete);
        void __fastcall FIBExTreeList1AfterExchangeItem(TObject *Sender,
          TListItem *Item);
        void __fastcall FIBExTreeList1AfterInsertItem(TObject *Sender,
          TListItem *Item);
        void __fastcall FIBExTreeList1BeforeInsertItem(TObject *Sender,
          AnsiString &S, int &ImIndex, int &StIndex);
        void __fastcall AutoUnCheckParentsClick(TObject *Sender);
        void __fastcall ComboBox8Change(TObject *Sender);
        void __fastcall CB_LINESClick(TObject *Sender);
        void __fastcall CB_ROWSELECTClick(TObject *Sender);
        void __fastcall CB_CUSTOM_COLORClick(TObject *Sender);
        void __fastcall CB_CUSTOM_TEXTClick(TObject *Sender);
        void __fastcall FIBExTreeColumnList1GetItemInfo(TObject *Sender,
          TTreeNode *Node, int iColumn, AnsiString &ItemText,
          TColor &ItemColor);
        void __fastcall FIBExTreeView1AfterCheck(TObject *Sender,
          TTreeNode *Node, bool Checked);
        void __fastcall TBC_CHECKALLClick(TObject *Sender);
        void __fastcall TBC_UNCHECKALLClick(TObject *Sender);
        void __fastcall ComboLevelsChange(TObject *Sender);
        void __fastcall ComboFilterChange(TObject *Sender);
        void __fastcall E_FILTERKeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
        void __fastcall E_LFILTERKeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
        void __fastcall ComboLFilterChange(TObject *Sender);
        void __fastcall TBL_USERTESTClick(TObject *Sender);
        void __fastcall TBL_ADDITEMClick(TObject *Sender);
        void __fastcall TBL_ADDCHILDClick(TObject *Sender);
        void __fastcall TBL_EDITClick(TObject *Sender);
        void __fastcall TBL_DELETEClick(TObject *Sender);
        void __fastcall ImageComboBox3Change(TObject *Sender);
        void __fastcall ImageComboBox4Change(TObject *Sender);
        void __fastcall TBL_SORTClick(TObject *Sender);
        void __fastcall TBL_UPClick(TObject *Sender);
        void __fastcall TBL_DNClick(TObject *Sender);
        void __fastcall TBL_TOPClick(TObject *Sender);
        void __fastcall TBL_DOWNClick(TObject *Sender);
        void __fastcall TBL_COLLAPSEClick(TObject *Sender);
        void __fastcall TBL_EXPANDClick(TObject *Sender);
        void __fastcall TBL_LOCATEClick(TObject *Sender);
        void __fastcall FIBExTreeColumnList1Change(TObject *Sender,
          TTreeNode *Node);
        void __fastcall FIBExTreeColumnList1AfterUpdateImage(
          TObject *Sender, TTreeNode *Node);
        void __fastcall FIBExTreeColumnList1BeforeInsertNode(
          TObject *Sender, TTreeNode *ParentNode, AnsiString &S,
          int &ImIndex, int &StIndex, TStrings *UserParams);
        void __fastcall TBL_FILTERClick(TObject *Sender);
        void __fastcall ComboLLevelsChange(TObject *Sender);
        void __fastcall ComboCFilterChange(TObject *Sender);
        void __fastcall E_CFILTERKeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
        void __fastcall ComboBLevelsChange(TObject *Sender);
        void __fastcall AutoUnCheckChildrenClick(TObject *Sender);
        void __fastcall AutoCheckParentsClick(TObject *Sender);
        void __fastcall PageDynControlChange(TObject *Sender);
        void __fastcall TB_DBACKClick(TObject *Sender);
        void __fastcall FIBExDynTreeList1DblClick(TObject *Sender);
        void __fastcall FIBExDynTreeComboBox1CloseUp(TObject *Sender,
          bool Selected);
        void __fastcall RLevel0Click(TObject *Sender);
        void __fastcall ChangeLevelStyle(void);
        void __fastcall PageTreesChange(TObject *Sender);
        void __fastcall FIBExDynTreeView1GetSelectSql(TObject *Sender,
          TTreeNode *ParentNode, TStrings *SelectSql);
        void __fastcall FIBExDynTreeList1GetSelectSql(TObject *Sender,
          int LevelIndex, TStrings *SelectSql);
        void __fastcall CB_DLINESClick(TObject *Sender);
        void __fastcall CB_DROWSELECTClick(TObject *Sender);
        void __fastcall CB_DCUSTOM_COLORClick(TObject *Sender);
        void __fastcall CB_DCUSTOM_TEXTClick(TObject *Sender);
        void __fastcall FIBExDynTreeColumnList1GetItemInfo(TObject *Sender,
          TTreeNode *Node, int iColumn, AnsiString &ItemText,
          TColor &ItemColor);
        void __fastcall CheckBox8Click(TObject *Sender);
        void __fastcall RG_COMBO1Click(TObject *Sender);
        void __fastcall CB_DFEXClick(TObject *Sender);
        void __fastcall CB_DSLSClick(TObject *Sender);
private:	// User declarations
        bool DisableRG;
        inline void TestSelected(TFIBExTreeView *Tree)
        {
         if (Tree->Selected == NULL)
         throw Exception("Select item for operation!");
        }
        void __fastcall UpdateTreeStateCheckButtons(void);
        void __fastcall UpdateColumnTreeStateCheckButtons(void);        
        void __fastcall UpdateListStateCheckButtons(void);
public:		// User declarations
        __fastcall TF_main(TComponent* Owner);
        bool __fastcall  Locate(String Val, int LType, int LMode);
        bool __fastcall  LocateNext(void);
};
//---------------------------------------------------------------------------
extern PACKAGE TF_main *F_main;
//---------------------------------------------------------------------------
#endif
