//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "u_sortlist.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TF_sortlist *F_sortlist;
//---------------------------------------------------------------------------
__fastcall TF_sortlist::TF_sortlist(TComponent* Owner)
        : TForm(Owner)
{
}

//---------------------------------------------------------------------------

void __fastcall TF_sortlist::RestoreButtons(void)
{
  SB_BTOP->Enabled = ((ListBox1->Items->Count > 1) & (ListBox1->ItemIndex > 0));
  SB_BBOTTOM->Enabled =((ListBox1->ItemIndex > -1) &
                       (ListBox1->ItemIndex < (ListBox1->Items->Count - 1))
                       & (ListBox1->Items->Count > 1));
}

//---------------------------------------------------------------------------

void __fastcall TF_sortlist::FormShow(TObject *Sender)
{
  RestoreButtons();
}
//---------------------------------------------------------------------------

void __fastcall TF_sortlist::ListBox1Click(TObject *Sender)
{
  RestoreButtons();        
}
//---------------------------------------------------------------------------
void __fastcall TF_sortlist::ListBox1DragDrop(TObject *Sender, TObject *Source,
      int X, int Y)
{
  int NewIndex = ListBox1->ItemAtPos(Point(X,Y),True);
  ListBox1->Items->Move(ListBox1->ItemIndex, NewIndex);
  if (NewIndex == -1) NewIndex = ListBox1->Items->Count-1;
  ListBox1->ItemIndex = NewIndex;
  RestoreButtons();
}
//---------------------------------------------------------------------------
void __fastcall TF_sortlist::ListBox1DragOver(TObject *Sender,
      TObject *Source, int X, int Y, TDragState State, bool &Accept)
{
  Accept = (Sender = Source);        
}
//---------------------------------------------------------------------------
void __fastcall TF_sortlist::SB_BTOPClick(TObject *Sender)
{
  if (ListBox1->ItemIndex != 0) {
  ListBox1->Items->Exchange(ListBox1->ItemIndex,ListBox1->ItemIndex-1);
  RestoreButtons(); }
}
//---------------------------------------------------------------------------
void __fastcall TF_sortlist::SB_BBOTTOMClick(TObject *Sender)
{
  if (ListBox1->ItemIndex != (ListBox1->Items->Count-1)) {
  ListBox1->Items->Exchange(ListBox1->ItemIndex,ListBox1->ItemIndex+1);
  RestoreButtons(); }
}
//---------------------------------------------------------------------------
