unit u_locate;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls, 
  Buttons, ExtCtrls;

type
  TF_locate = class(TForm)
    B_START: TButton;
    B_CANCEL: TButton;
    Edit1: TEdit;
    RG_Locate: TRadioGroup;
    RG_LMODE: TRadioGroup;
    B_NEXT: TButton;
    procedure FormShow(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure B_STARTClick(Sender: TObject);
    procedure B_CANCELClick(Sender: TObject);
    procedure B_NEXTClick(Sender: TObject);
    procedure RG_LocateClick(Sender: TObject);
  private
   //
  public
    { Public declarations }
  end;

var
  F_locate: TF_locate;

implementation

uses u_main;

{$R *.DFM}

procedure TF_locate.FormShow(Sender: TObject);
begin
  Edit1.Clear;
end;

procedure TF_locate.Edit1Change(Sender: TObject);
begin
  B_START.Enabled:=True;
  B_NEXT.Enabled:=False;
end;

procedure TF_locate.RG_LocateClick(Sender: TObject);
begin
  RG_LMODE.Enabled:=(RG_LOCATE.ItemIndex = 0);
  Edit1Change(Sender);
end;

procedure TF_locate.B_STARTClick(Sender: TObject);
var FindResult: boolean;
begin
  FindResult:=False;
  if Edit1.Text <> '' then
  try
    FindResult:=F_main.Locate(Edit1.Text, RG_LOCATE.ItemIndex, RG_LMODE.ItemIndex);
  finally
    B_NEXT.Enabled:=FindResult;
    B_START.Enabled:=(not B_NEXT.Enabled);
  end;
end;

procedure TF_locate.B_NEXTClick(Sender: TObject);
begin
  B_NEXT.Enabled:=F_main.LocateNext;
  B_START.Enabled:=not B_NEXT.Enabled;
end;

procedure TF_locate.B_CANCELClick(Sender: TObject);
begin
  close;
end;


end.
