{==============================================================================
 ======================  FIBExTrees library v 4.1 =============================
 ==============================================================================
 ======== Igor Ilyinsky 2003-2006 www.sinn.ru/~mapnn (mapnn@sinn.ru) ==========
 ==============================================================================}

unit FIBExTreesConsts;

interface

ResourceString

  // internal popup menu

  SPMAddItem = 'Add Item';
  SPMAddChildItem = 'Add Child Item';
  SPMEditItem = 'Edit Item';
  SPMDeleteItem = 'Delete Item';
  SPMSetImage = 'Set Image for Item';
  SPMSetStateImage = 'Set StateImage for Item';
  SPMNoImage = 'None';
  SPMMoveUp = 'Move Up';
  SPMMoveDown = 'Move Down';
  SPMMoveUpLevel = 'Move Up One Level';
  SPMMoveDownLevel = 'Move Down One Level';
  SPMSortItems = 'Sort Items';
  SPMLocateItems = 'Locate Items';

  // locate dialog

  SLDCaption = 'Locate items';
  SLDRBSTCaption = 'Starting with';
  SLDRBCTCaption = 'Containing';
  SLDBFCaption = 'Locate';
  SLDBNCaption = 'Locate Next';
  SLDBCCaption = 'Close';
  SLDNotFound = 'Not Found!';
  SLDNotFoundMore = 'Not Found more!';

  // sort dialog

  SSDCaption = 'Sort items';
  SSDOKBtnCaption = 'Ok';
  SSDCancelBtnCaption = 'Cancel';

  // TFIBExTreeView/List

  STVDBNotConnected = '%s: database not connected!';
  STVPropertyNotDefined = '%s: property %s not defined!';
  STVBadCheckRadioStyle = '%s: style is not CheckBox or RadioGroup!';
  STVBadCheckStyle = '%s: style is not CheckBox!';
  STVCantMoveItemInSelf = '%s: can`t move item in self!';
  STVCantExchangeItemInSelf = '%s: can`t exchange item in self!';
  STVCantExchangeItemDifParent = '%s: can`t exchange item for diffrent Parent!';
  STVUserFieldNotExists = '%s: UserField %s not exists!';
  STVUserFieldIsReadOnly = '%s: UserField %s is ReadOnly!';

  // TFIBExDynTreeView

  STVLevelPropertyNotDefined = '%s: Levels[%d]: property %s not defined!';
  STVReloadNodesDisabled = '%s: ReloadNodesOnExpand disabled for CheckBox and RadioGroup level style!';
  STVCheckStyleDisabled = '%s: CheckBox and RadioGroup level style disabled for ReloadNodesOnExpand!';
  STVCheckStyleComboDisabled = '%s: CheckBox and RadioGroup level style disabled for ComboBox!';

  // metadata creator

  SMDCreatorDlgCaption = 'FIBExTrees MetaData Creator';
  SMDMTitleLabelCaption = 'Select Fields Length for Table of Tree:';
  SMDMEditLabel1Caption = 'Field_Name Length';
  SMDMEditLabel2Caption = 'Field_FullPath Length';
  SMDMCB_PROCCaption    = 'Create TreeSortProc';
  SMDMLabelCaption = 'You must have permission for create metadata!';
  SMDBFCaption = 'Create';
  SMDBCCaption = 'Close';
  SMDDatabaseNotDefined = '%s: Property Database not defined!';
  SMDDatabaseConnect = 'Connect to Database ...';
  SMDTestMetadataDef = 'Test Metadata definitions ...';
  SMDPropertyNotDefined = '%s: roperty <%s> not defined!';
  SMDBadFieldLength = 'Bad %s Length!';
  SMDBigFieldLength = '%s Length is too big! Please, set Length <= %s!';
  SMDSmallFieldLength = '%s Length is too small! Please, set Length between %s and %s!';
  SMDTestExistingMetadata = 'Test existing Metadata ...';
  SMDTableExists = '%s: Table <%s> already exists!';
  SMDGeneratorExists = '%s: Generator <%s> already exists!';
  SMDProcedureExists = '%s: Procedure <%s> already exists!';
  SMDCreateTableMetadata = 'Create %s Metadata ...';
  SMDMemoStatusOk = ' Ok';
  SMDProcessSuccess = 'Success!';


implementation

end.
