//---------------------------------------------------------------------------

#ifndef u_mainH
#define u_mainH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "FIBDatabase.hpp"
#include "FIBDataSet.hpp"
#include "FIBExTreeComboBox.hpp"
#include "FIBExTreeList.hpp"
#include "FIBExTreeView.hpp"
#include "ImageComboBox.hpp"
#include "pFIBDatabase.hpp"
#include "pFIBDataSet.hpp"
#include <ComCtrls.hpp>
#include <DB.hpp>
#include <DBGrids.hpp>
#include <Dialogs.hpp>
#include <ExtCtrls.hpp>
#include <Grids.hpp>
#include <ImgList.hpp>
#include <Mask.hpp>
#include <Menus.hpp>
#include <ToolWin.hpp>
//---------------------------------------------------------------------------
class TF_main : public TForm
{
__published:	// IDE-managed Components
        TPageControl *PageControl1;
        TTabSheet *TabSheet1;
        TStatusBar *StatusBar1;
        TToolBar *ToolBar2;
        TPanel *Panel1;
        TLabel *Label1;
        TComboBox *ComboBox1;
        TPanel *Panel2;
        TComboBox *ComboBox2;
        TToolButton *TB_CHECLALL;
        TToolButton *TB_UNCHECLALL;
        TToolBar *ToolBar1;
        TToolButton *TB_ADDITEM;
        TToolButton *TB_ADDCHILD;
        TToolButton *TB_EDIT;
        TToolButton *TB_DELETE;
        TImageComboBox *ImageComboBox1;
        TImageComboBox *ImageComboBox2;
        TToolButton *TB_SORT;
        TToolButton *TB_UP;
        TToolButton *TB_DN;
        TToolButton *TB_TOP;
        TToolButton *TB_DOWN;
        TToolButton *ToolButton8;
        TToolButton *TB_COLLAPSE;
        TToolButton *TB_EXPAND;
        TToolButton *ToolButton1;
        TToolButton *TB_LOCATE;
        TToolButton *ToolButton2;
        TToolButton *TB_FILTER;
        TFIBExTreeView *FIBExTreeView1;
        TTabSheet *TabSheet3;
        TSplitter *Splitter2;
        TPanel *Panel7;
        TPanel *Panel8;
        TFIBExTreeView *FIBExTreeView4;
        TPanel *Panel9;
        TPanel *Panel10;
        TToolBar *ToolBar3;
        TToolButton *TB_BACK;
        TToolButton *ToolButton4;
        TToolButton *TB_LARGE;
        TToolButton *TB_SMALL;
        TToolButton *TB_LIST;
        TToolButton *TB_REPORT;
        TLabel *Label4;
        TToolBar *ToolBar4;
        TPanel *Panel11;
        TLabel *Label5;
        TComboBox *ComboBox3;
        TPanel *Panel12;
        TComboBox *ComboBox4;
        TToolButton *TBL_CHECKALL;
        TToolButton *TBL_UNCHECKALL;
        TFIBExTreeList *FIBExTreeList1;
        TTabSheet *TabSheet4;
        TPanel *Panel4;
        TPanel *Panel6;
        TFIBExTreeView *FIBExTreeView5;
        TPanel *Panel5;
        TLabel *Label3;
        TGroupBox *GroupBox1;
        TCheckBox *CheckBox1;
        TCheckBox *CheckBox4;
        TCheckBox *CheckBox3;
        TRadioGroup *RadioGroup1;
        TGroupBox *GroupBox2;
        TCheckBox *CheckBox2;
        TButton *Button1;
        TCheckBox *CheckBox5;
        TFIBExTreeComboBox *FIBExTreeComboBox1;
        TTabSheet *TabSheet5;
        TSplitter *Splitter1;
        TPanel *Panel3;
        TLabel *Label2;
        TLabel *Label7;
        TLabel *Label8;
        TLabel *Label9;
        TComboBox *ComboBox5;
        TComboBox *ComboBox6;
        TComboBox *ComboBox7;
        TCheckBox *CheckCopyImages;
        TFIBExTreeView *FIBExTreeView3;
        TFIBExTreeView *FIBExTreeView2;
        TTabSheet *TabSheet2;
        TSplitter *Splitter3;
        TPanel *Panel13;
        TLabel *Label6;
        TCheckBox *CheckBox6;
        TDBGrid *DBGrid1;
        TButton *B_CREATEDATA;
        TFIBExTreeView *FIBExTreeView6;
        TTabSheet *TabSheet6;
        TPanel *Panel14;
        TDBGrid *DBGrid2;
        TMainMenu *MainMenu1;
        TMenuItem *File1;
        TMenuItem *Exit1;
        TMenuItem *Edit1;
        TMenuItem *AddItem1;
        TMenuItem *AddChilditem1;
        TMenuItem *Edititem1;
        TMenuItem *DeleteItem1;
        TMenuItem *N5;
        TMenuItem *Checkallitems;
        TMenuItem *Uncheckallitems;
        TMenuItem *N1;
        TMenuItem *Sortitems1;
        TMenuItem *Moveoneup;
        TMenuItem *Moveonedown;
        TMenuItem *Moveonetoplevel;
        TMenuItem *Moveonedownlevel;
        TMenuItem *Option1;
        TMenuItem *EditItemsafterInsert;
        TMenuItem *UpdateImagelevel;
        TMenuItem *HideTreePopUpImages1;
        TMenuItem *N4;
        TMenuItem *CaskadeCheckChildren;
        TMenuItem *DisableCheck;
        TMenuItem *View1;
        TMenuItem *OpHideImages;
        TMenuItem *OpHideStateImages;
        TMenuItem *OpShowFieldID;
        TMenuItem *N2;
        TMenuItem *FullCollapse1;
        TMenuItem *FullExpand1;
        TMenuItem *Help1;
        TMenuItem *English1;
        TMenuItem *Russian1;
        TMenuItem *About1;
        TImageList *ImageTool;
        TImageList *ImageTree;
        TOpenDialog *OD;
        TImageList *ToolbarList;
        TImageList *ImageState;
        TDataSource *DataSource1;
        TDataSource *DataSource2;
        TpFIBDatabase *IBD;
        TpFIBTransaction *Tr_Read;
        TpFIBTransaction *Tr_Write;
        TpFIBDataSet *pFIBDataSet1;
        TpFIBDataSet *pFIBDataSet2;
        TFIBIntegerField *pFIBDataSet2ID;
        TFIBIntegerField *pFIBDataSet2PARENT;
        TFIBStringField *pFIBDataSet2NAME;
        TFIBIntegerField *pFIBDataSet2CCOUNT;
        TFIBIntegerField *pFIBDataSet2SORTINDEX;
        TFIBIntegerField *pFIBDataSet2IMAGEINDEX;
        TFIBIntegerField *pFIBDataSet2STATEINDEX;
        TFIBIntegerField *pFIBDataSet2NODE_LEVEL;
        TFIBStringField *pFIBDataSet2FULLPATH;
private:	// User declarations
public:		// User declarations
        __fastcall TF_main(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TF_main *F_main;
//---------------------------------------------------------------------------
#endif
